package com.example.what_the_fantasy.data.services

import com.example.what_the_fantasy.data.model.Favorite
import com.example.what_the_fantasy.data.model.Comment
import com.example.what_the_fantasy.data.model.Quote
import com.example.what_the_fantasy.data.model.SrcLanguage
import com.example.what_the_fantasy.data.model.User
import com.example.what_the_fantasy.ui.states.AuthUserState
import com.example.what_the_fantasy.ui.viewModels.CurrentUserViewModel
import kotlinx.coroutines.flow.StateFlow

interface IServices {

    suspend fun validLogin(username : String,
                           passwd : String,
                           navController: (Int) -> Unit,
                           initialierCurrentUser : (Int) ->Unit,
                           currentUserViewModel: CurrentUserViewModel
    ): Boolean

    suspend fun EditUsername(username : String, index : Int, currentUserViewModel: CurrentUserViewModel) : Boolean
    suspend fun EditEmail(email : String, index : Int,currentUserViewModel: CurrentUserViewModel) : Boolean
    suspend fun EditPasswd(passwd : String, index : Int,currentUserViewModel : CurrentUserViewModel): Boolean
    suspend fun EditImage(index : Int,currentUserViewModel : CurrentUserViewModel) : String
    suspend fun ChangeLangage(index : Int, currentUserViewModel : CurrentUserViewModel): SrcLanguage
    fun isUsernameExist(username : String) : Boolean
    fun isEmailExist(email : String) : Boolean

    fun AddFav(userId: Int, QuoteId : Int)
    fun SupFav(userId: Int, QuoteId : Int)
    fun AddComment(content : String)
    fun CreateUser(username : String, email : String, passwd : String) : Boolean
    fun getFavorite(user: User): List<Quote>
    fun getAllUsers(): List<User>
    fun getComment(quoteId : Int) : List<Comment>
    suspend fun getUserById(id: Int): User?

    fun getQuote( id : Int): Quote?

    suspend fun isFavorite(idQuote : Int, iduser: Int): Boolean
    fun getAllFavorite(): List<Favorite>
    fun getAllQuote(): List<Quote>
    fun getSomeQuotes(nb: Int, page: Int) : MutableList<Quote>
    suspend fun getDalyQuote(langage : SrcLanguage) : Quote
    fun search(type : String ,search:String ,indexCount: Int): List<Quote>
}