package com.example.what_the_fantasy.data.services

import android.os.Build
import android.util.Log
import androidx.annotation.RequiresApi
import com.example.what_the_fantasy.data.local.ImageStub.allImages
import com.example.what_the_fantasy.data.model.Comment
import com.example.what_the_fantasy.data.model.Favorite
import com.example.what_the_fantasy.data.model.Quote
import com.example.what_the_fantasy.data.model.SrcLanguage
import com.example.what_the_fantasy.data.model.User
import com.example.what_the_fantasy.data.retrofit.RetrofitInstance
import com.example.what_the_fantasy.ui.viewModels.CurrentUserViewModel
import java.time.LocalDate
import java.util.Date

//import com.example.what_the_fantasy.data.model.Comment
//import com.example.what_the_fantasy.data.model.Favorite
//import com.example.what_the_fantasy.data.model.Quote
//import com.example.what_the_fantasy.data.model.User
////import com.example.what_the_fantasy.ui.navigations.Destination

class ServicesAPI : IServices {

    override suspend fun validLogin(
        username: String,
        passwd: String,
        navController: (Int) -> Unit,
        initialierCurrentUser: (Int) -> Unit,
        currentUserViewModel: CurrentUserViewModel
    ): Boolean {
        try {
            val response = RetrofitInstance.api.getUserByUsername(username) // on récupère l'utilisateur
            val hashedPasswordAPI = response.password // récupère le mot de passe de l'api
            val index =response.id
            //val hashPassWd = hashPassword(passwd)// hache mot de passe demandé

            if (passwd == hashedPasswordAPI) { // on compare les deux mots de passe
                navController(index)
                initialierCurrentUser(index)
                currentUserViewModel.setUser(response)
                return true
            }
            else {
                return false
            }
        } catch (e: Exception) {
            return false
        }
    }

    override suspend fun EditUsername(username: String, index: Int, currentUserViewModel: CurrentUserViewModel): Boolean {
        try {
            val userExistsResponse = RetrofitInstance.api.checkIfUsernameExists(username)

            Log.d("EditUsername", "Username check: $username exists = $userExistsResponse")

            if (userExistsResponse) {
                Log.d("EditUsername", "Username $username already exists, cannot update.")
                return false
            }

            val responseUser = RetrofitInstance.api.getUserById(index)

            val updatedUser = User(
                id = index,
                username = username, // Nouveau nom d'utilisateur
                email = responseUser.email,
                password = responseUser.password,
                imgUrl = responseUser.imgUrl,
                langage = responseUser.langage,
                date = responseUser.date
            )

            val response = RetrofitInstance.api.updateUsername(index, updatedUser)

            if (response.isSuccessful) {
                currentUserViewModel.setUser(updatedUser)
                Log.d("EditUsername", "Username updated successfully.")
                return true
            } else {
                Log.d("EditUsername", "Failed to update username, API response not successful.")
                return false
            }
        } catch (e: Exception) {
            e.printStackTrace()
            Log.d("EditUsername", "Exception occurred: ${e.message}")
            return false
        }
    }


    override suspend fun EditEmail(email: String, index: Int,currentUserViewModel: CurrentUserViewModel): Boolean {
        try {
            val userExistsResponse = RetrofitInstance.api.checkIfEmailExists(email)

            if (userExistsResponse) {
                Log.d("EditEmail", "Exception occurred: The email alredy exist")
                return false
            }

            val responseUser = RetrofitInstance.api.getUserById(index)

            val updatedUser = User(
                id = index,
                username = responseUser.username,
                email = email,// Nouvel email d'utilisateur
                password = responseUser.password,
                imgUrl = responseUser.imgUrl,
                langage = responseUser.langage,
                date = responseUser.date
            )

            val response = RetrofitInstance.api.updateUsername(index, updatedUser)

            if (response.isSuccessful) {
                currentUserViewModel.setUser(updatedUser)
                return true
            } else {
                return false
            }
        } catch (e: Exception) {
            e.printStackTrace()
            Log.d("EditEmail", "Exception occurred: ${e.message}")
            return false
        }
    }

    override suspend fun EditPasswd(passwd: String, index: Int, currentUserViewModel: CurrentUserViewModel): Boolean {
        try {
            val responseUser = RetrofitInstance.api.getUserById(index)

            val updatedUser = User(
                id = index,
                username = responseUser.username,
                email = responseUser.username,
                password = passwd,
                //password = hashPassword(passwd),
                imgUrl = responseUser.imgUrl,
                langage = responseUser.langage,
                date = responseUser.date
            )

            val response = RetrofitInstance.api.updateUsername(index, updatedUser)

            if (response.isSuccessful) {
                currentUserViewModel.setUser(updatedUser)
                return true
            } else {
                return false
            }
        } catch (e: Exception) {
            e.printStackTrace()
            Log.d("EditPasswd", "Exception occurred: ${e.message}")
            return false
        }
    }

    override suspend fun EditImage(index: Int, currentUserViewModel : CurrentUserViewModel): String {
        try {

            val responseUser = RetrofitInstance.api.getUserById(index)

            val updatedUser = User(
                id = index,
                username = responseUser.username,
                email = responseUser.email,// Nouvel email d'utilisateur
                password = responseUser.password,
                imgUrl = randomImage(),
                langage = responseUser.langage,
                date = responseUser.date
            )

            val response = RetrofitInstance.api.updateUsername(index, updatedUser)

            if (response.isSuccessful) {
                currentUserViewModel.setUser(updatedUser)
                return updatedUser.imgUrl
            } else {
                return responseUser.imgUrl
            }
        } catch (e: Exception) {
            e.printStackTrace()
            return ""
            Log.d("EditEmail", "Exception occurred: ${e.message}")
        }
    }




    override suspend fun ChangeLangage(index: Int, currentUserViewModel : CurrentUserViewModel): SrcLanguage {
        val responseUser = RetrofitInstance.api.getUserById(index)
        var langage : SrcLanguage

        if(responseUser.langage == SrcLanguage.vf){
            langage = SrcLanguage.vo
        }
        else{
            langage = SrcLanguage.vf
        }

        val updatedUser = User(
            id = index,
            username = responseUser.username,
            email = responseUser.email,
            password = responseUser.password,
            imgUrl = responseUser.imgUrl,
            langage = langage,
            date = responseUser.date
        )
        RetrofitInstance.api.updateUsername(index, updatedUser)
        currentUserViewModel.setUser(updatedUser)
        return langage
    }

    override fun isUsernameExist(username: String): Boolean {
        TODO("Not yet implemented")
    }

    override fun isEmailExist(email: String): Boolean {
        TODO("Not yet implemented")
    }

    override fun AddFav(userId: Int, QuoteId: Int) {
        TODO("Not yet implemented")
    }

    override fun SupFav(userId: Int, QuoteId: Int) {
        TODO("Not yet implemented")
    }

    override fun AddComment(content: String) {
        TODO("Not yet implemented")
    }

    override fun CreateUser(username: String, email: String, passwd: String): Boolean {
        TODO("Not yet implemented")
    }

    override fun getFavorite(user: User): List<Quote> {
        TODO("Not yet implemented")
    }

    override fun getAllUsers(): List<User> {
        TODO("Not yet implemented")
    }

    override fun getComment(quoteId: Int): List<Comment> {
        TODO("Not yet implemented")
    }

    override suspend fun getUserById(id: Int): User {
        return RetrofitInstance.api.getUserById(id)
    }

    override fun getQuote(id: Int): Quote? {
        TODO("Not yet implemented")
    }

    override suspend fun isFavorite(idQuote: Int, iduser: Int): Boolean {
        TODO("Not yet implemented")
    }

    override fun getAllFavorite(): List<Favorite> {
        TODO("Not yet implemented")
    }

    override fun getAllQuote(): List<Quote> {
        TODO("Not yet implemented")
    }

    override fun getSomeQuotes(nb: Int, page: Int): MutableList<Quote> {
        TODO("Not yet implemented")
    }

    @RequiresApi(Build.VERSION_CODES.O)
    override suspend fun getDalyQuote(langage : SrcLanguage): Quote {
        val today = LocalDate.now()
        return RetrofitInstance.api.getDailyQuote(today.year, today.monthValue, today.dayOfMonth, langage)
    }

    override fun search(type: String, search: String, indexCount: Int): List<Quote> {
        TODO("Not yet implemented")
    }


    //-------------------------------------------------------
    suspend fun randomImage() : String{
        val imagesList = RetrofitInstance.api.getAllImages(0, 300)
        val sizeList = imagesList.size
        return RetrofitInstance.api.getImageById((0..sizeList).random()).url
    }

}